/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	SmartForce学習開始URL作成クラス
//			変更履歴
//				2004.01.08	新規作成	五木田　泰史
//
package jp.co.ntt.lms.lo.SmartForce;

import java.util.*;
import java.net.URLEncoder;
import java.io.UnsupportedEncodingException;

import jp.co.ntt.lms.lo.*;

/**
 * スマートフォース学習開始URL作成クラス
 *
 * <PRE>
 * 学習開始URLを組み立てる。
 * </PRE>
 */
public class SmartForceLoURLMaker
	implements SmartForceLoPropertyDef
{
	/**
	 * スマートフォース学習開始URL作成
	 *
	 * @param Hashtable パラメータリスト
	 * @return String WBT学習開始URL
	 * @exception LOException Lo固有の例外エラー
	 */
	public String makeStartLearnURL(Hashtable htbParam)
		throws LOException, UnsupportedEncodingException
	{
		try
		{
			// スマートフォース教材詳細情報を設定します
			setSmartForceLoData( htbParam );
			// セッションIDの設定

			String strMaterialID = (String)htbParam.get( COURSECODE );

			if( strMaterialID != null ) {
				htbParam.put( SESSIONID, strMaterialID );
			}
			// 戻り値初期化
			String strRet       = "";
			// 戻りURL初期化
			String strReturnURL = "";
			// スマートフォース教材環境クラスのインスタンス化
			SmartForceLoEnv objEnv = new SmartForceLoEnv();
			// 戻りURLをEndLearnServletにする
			strReturnURL        = objEnv.getEndLearnServletURL(htbParam);
			// 戻りページのエンコード
			strReturnURL        = URLEncoder.encode(strReturnURL, "UTF-8");
			// 戻りURLの再設定
			htbParam.put(RETURN_URL, strReturnURL);
			strRet              = objEnv.getOpenURL(htbParam);
			return strRet;
		}
		catch(LOException le)
		{
			le.printStackTrace();
			throw le;
		}
		catch(UnsupportedEncodingException e) {
			throw e;
		}	
	}

	/**
	 * スマートフォース教材詳細情報を設定します
	 */
	private void setSmartForceLoData( Hashtable htbParam )
		throws LOException
	{
		// Dataアクセスクラスを使用して、詳細情報を取得する
		SmartForceLoDataAccess objDataAccess = new SmartForceLoDataAccess();
		SmartForceLoData[] objData = objDataAccess.getData( htbParam );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// 教材IDの設定
			htbParam.put( COURSECODE, objData[i].getCourseCode() );
			htbParam.put( MATVERSION, objData[i].getVersion() );
		}
	}
}


